## subterfugue 0.2.1a

=== Makefile ===
# SUBTERFUGUE makefile

#	$Header: /cvsroot/subterfugue/subterfugue/Makefile,v 1.16 2001/12/04 05:36:08 mkc Exp $


.PHONY : all compilepy dist pushdist install install_compiled dpkg \
		clean distclean

# installation directory
DESTDIR =

# FIX: this breaks in version 10?
PYTHON_VERSION = $(shell python -c 'import sys; print sys.version[:3]')
PYTHON_COMMAND = python

SUBTERFUGUE_ROOT = /usr/lib/subterfugue
PYTHON_SITE = /usr/lib/python$(PYTHON_VERSION)/site-packages

PYTHON_MODULES = modules/ptracemodule.so modules/svr4module.so \
			modules/linuxmodule.so
SUBTERFUGUE_MODULES = modules/_subterfuguemodule.so
MODULES = $(PYTHON_MODULES) $(SUBTERFUGUE_MODULES)

all :: $(MODULES) sf dsf compilepy

sf : sf.in
	sed -e 's|^\(export SUBTERFUGUE_ROOT=\).*$$|\1'$(SUBTERFUGUE_ROOT)'|' \
	    -e 's|python-command|$(PYTHON_COMMAND)|' \
		$< > $@ || rm $@

# development version of 'sf'
dsf : sf.in
	sed -e 's|^\(export SUBTERFUGUE_ROOT=\).*$$|\1'$$PWD'|' \
	    -e 's|python-command|$(PYTHON_COMMAND)|' \
	    -e 's|#DSF#||' \
		$< > $@ || rm $@
	chmod a+rx $@

compilepy ::
	$(PYTHON_COMMAND)    -c 'import compileall; compileall.main()' .
	$(PYTHON_COMMAND) -O -c 'import compileall; compileall.main()' .

modules/%.so : modules/%.c
	cd modules \
	&& (test -e Makefile.pre.in \
	    || ln -s /usr/lib/python$(PYTHON_VERSION)/config/Makefile.pre.in) \
	&& make -f Makefile.pre.in boot \
	&& make

version := $(shell python version.py | awk '{ print $$1 }')
distdir := subterfugue-$(version)
distfile := $(distdir).tgz

debfile := subterfugue_$(version)-1_i386.deb
# rpmfile := subterfugue-$(version)-1.i386.rpm

dist :: 
	$(MAKE) distclean
	rm -f ../$(distdir)
	cd .. && ln -s subterfugue $(distdir) \
		&& tar cfh - --exclude=CVS $(distdir) \
		| gzip --best > $(distfile)
	rm -f ../$(distdir)
	@echo 'Did you do a "cvs update/commit" first?'
	@echo 'Do a "cvs rtag -FR release-$(version) <modules>"'

pushdist ::
	[ -e ../$(distfile) -a -e ../$(debfile) ] || exit 1
	cd .. && ncftpput -V upload.sourceforge.net /incoming \
		$(distfile) $(debfile)

install ::
	install -d $(DESTDIR)$(SUBTERFUGUE_ROOT)/tricks
	install -d $(DESTDIR)$(PYTHON_SITE)
	install -d $(DESTDIR)/usr/bin
	install -d $(DESTDIR)/usr/share/man/man1
	install -d $(DESTDIR)/usr/share/doc/subterfugue
	install --mode=444 *.py $(DESTDIR)$(SUBTERFUGUE_ROOT)
	install --mode=444 tricks/*.py \
		$(DESTDIR)$(SUBTERFUGUE_ROOT)/tricks
	install $(PYTHON_MODULES) $(DESTDIR)$(PYTHON_SITE)
	install $(SUBTERFUGUE_MODULES) $(DESTDIR)$(SUBTERFUGUE_ROOT)
	install sf $(DESTDIR)/usr/bin
	install scripts/herekitty $(DESTDIR)/usr/bin
	install doc/*.1 $(DESTDIR)/usr/share/man/man1
	install README NEWS CREDITS INTERNALS \
		$(DESTDIR)/usr/share/doc/subterfugue

install_compiled :: install
	install --mode=444 *.{pyo,pyc} $(DESTDIR)$(SUBTERFUGUE_ROOT)
	install --mode=444 tricks/*.{pyo,pyc} \
		$(DESTDIR)$(SUBTERFUGUE_ROOT)/tricks

dpkg ::
	dpkg-buildpackage -rfakeroot
	cd .. && f=`ls -1t subterfugue*.changes | head -1` \
		&& echo $$f && lintian -i $$f
	fakeroot debian/rules clean
	@cd .. && f=`ls -1t subterfugue*.changes | head -1` \
		&& echo 'Do a "dupload --to master '$$f'"'

clean ::
	-rm -f sf dsf
	-rm -f *.py[co] *~
	-cd modules && rm -f *~ *.o *.so Makefile{,.pre} sedscript config.c
	-cd tricks && rm -f *.py[co] *~
	-cd scripts && rm -f *~
	-cd doc && rm -f *~
	-cd test && $(MAKE) clean

distclean :: clean
	-cd modules && rm -f Setup Makefile.pre.in

## subterfugue 0.2.1a-1

=== debian/changelog ===
subterfugue (0.2.1a-1) unstable; urgency=medium

  * do the right thing when 'python' != 'python2.1' (closes: #122217)

 -- Mike Coleman <mkc@debian.org>  Mon,  3 Dec 2001 23:30:39 -0600

subterfugue (0.2.1-1) unstable; urgency=high

  * upgrade to conform to new Debian Python Policy (closes: #119237)
  * port to Python 2.1.1
  * fix poke bug (2.4 disallows writes to /proc/<n>/mem
  * add check for broken Red Hat kernel
  * fix compiler warnings
  * fix broken TimeWarp example

 -- Mike Coleman <mkc@debian.org>  Sun, 25 Nov 2001 22:21:23 -0600

subterfugue (0.2-1) unstable; urgency=medium

  * upgraded to work with 2.4 kernel
  * first version of package uploaded to Debian queue (closes: #78227)
  * other minor changes/improvements/bug fixes

 -- Mike Coleman <mkc@debian.org>  Tue, 20 Feb 2001 16:14:01 -0600

subterfugue (0.1.99a-1) unstable; urgency=low

  * fix bug that could allow process escape

 -- Mike Coleman <mkc@users.sourceforge.net>  Tue, 31 Oct 2000 00:24:14 -0600

subterfugue (0.1.99-1) unstable; urgency=low

  * initial Debian package release.

 -- Mike Coleman <mkc@users.sourceforge.net>  Sat, 28 Oct 2000 11:04:25 -0500

Local variables:
mode: debian-changelog
add-log-mailing-address: "mkc@debian.org"
End:

=== debian/control ===
Source: subterfugue
Section: utils
Priority: optional
Maintainer: Mike Coleman <mkc@debian.org>
Build-Depends: debhelper, python2.1-dev
Standards-Version: 3.1.1

Package: subterfugue
Architecture: i386
Depends: python2.1
Recommends: python-gtk
Description: Tool for subverting programs--"strace meets expect"
 SUBTERFUGUE is a framework for observing and playing with the reality of
 software; it's a foundation for building tools to do tracing, sandboxing, and
 many other things.  You could think of it as "strace meets expect."
 [requires 2.4 kernel]

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# when changing this, need to bump control and .postinst, too!
PYTHON_VERSION := 2.1
PYTHON_COMMAND = python$(PYTHON_VERSION)


# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
export DH_COMPAT=2

configure: configure-stamp
configure-stamp:
	dh_testdir
	# no real configure to be done
	touch configure-stamp

build: configure-stamp build-stamp
build-stamp:
	dh_testdir
	# Add here commands to compile the package.
	$(MAKE) PYTHON_VERSION=$(PYTHON_VERSION) PYTHON_COMMAND=$(PYTHON_COMMAND)
	#/usr/bin/docbook-to-man debian/subterfugue.sgml > subterfugue.1
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	# Add here commands to clean up after the build process.
	-$(MAKE) PYTHON_VERSION=$(PYTHON_VERSION) PYTHON_COMMAND=$(PYTHON_COMMAND) distclean
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs
	# Add here commands to install the package into debian/<packagename>
	$(MAKE) PYTHON_VERSION=$(PYTHON_VERSION) PYTHON_COMMAND=$(PYTHON_COMMAND) DESTDIR=`pwd`/debian/`dh_listpackages` install


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
#	dh_testversion
	dh_testdir
	dh_testroot
#	dh_installdebconf	
	dh_installdocs
#	dh_installexamples
	dh_installmenu
#	dh_installemacsen
#	dh_installpam
#	dh_installinit
#	dh_installcron
#	dh_installmanpages
	dh_installinfo
#	dh_undocumented
	dh_installchangelogs 
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	# You may want to make some executables suid here.
#	dh_suidregister
#	dh_makeshlibs
	dh_installdeb
#	dh_perl
#	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## subterfugue 0.2.1a-9.3

=== debian/changelog ===
subterfugue (0.2.1a-9.3) unstable; urgency=low

  * NMU at the Munich BugSquashin Party
  * Recommends: s/python-gtk/python-gtk2/ (Closes: #240572)

 -- Erich Schubert <erich@debian.org>  Sun, 18 Apr 2004 14:57:01 +0200

subterfugue (0.2.1a-9.2) unstable; urgency=low

  * NMU.
  * Apply patch to avoid type error (closes: #207749).

 -- Matthias Klose <doko@debian.org>  Sat, 27 Sep 2003 09:55:41 +0200

subterfugue (0.2.1a-9.1) unstable; urgency=low

  * NMU.
  * Update depends for pygtk transition (closes: #208121).
  * Update to python2.3.

 -- Matthias Klose <doko@debian.org>  Thu, 25 Sep 2003 21:03:03 +0200

subterfugue (0.2.1a-9) unstable; urgency=low

  * fix upcoming gtk transition to 2.0.  thanks seb128
  * RExec (a restricted execution framework) does not work anymore.  This
    breaks subterfugue.  Matthew Mueller sent a patch replacing it (it was not
    used to restrict the program running, only evaluation of arguments to
    subterfugue).  Closes: Bug#202312

 -- Thomas Smith <tgs@debian.org>  Tue, 22 Jul 2003 14:00:14 -0500

subterfugue (0.2.1a-8.1) unstable; urgency=low

  * try a fix for the doesn't-reap-children bug.
  * nope doesn't work yet.  try again soon.

 -- Thomas Smith <tgs@debian.org>  Sat, 19 Jul 2003 14:08:35 -0500

subterfugue (0.2.1a-8) unstable; urgency=medium

  * update MAXCALLNUMBER for the previous update.
  * make "ipc_subcall" syscalls look unique (hopefully this works again)
  * actually tested this time *kick self*

 -- Thomas Smith <tgs@debian.org>  Wed, 18 Jun 2003 18:42:48 -0500

subterfugue (0.2.1a-7) unstable; urgency=low

  * Make all the multiline strings in the C files into single line strings, so
    we can compile on gcc 3.3.  (Closes: Bug#197574)
  * Update the syscall map from strace 4.4.98.  The bug about this was
    actually fixed already in a later version, d'oh, but that transcription
    from strace was old, so here's a new one.  I should put a version in
    proposed-updates for people running stable with 2.4 kernels (you need this
    update).  I'll close the bug when I upload to proposed-updates.
    (Fixes: Bug#192731)
  * Updated Standards-Version to 3.5.10

 -- Thomas Smith <tgs@debian.org>  Mon, 16 Jun 2003 00:20:23 -0500

subterfugue (0.2.1a-6) unstable; urgency=low

  * Yann Dirson fixed two bugs:
    - Fixed ArgTrick not to mess with target in creatin of relative
      symlinks.  Closes: Bug#182694.
    - Fixed fd leak in Memory24 object, allowing to build a Linux kernel
      under Arg trick.  Closes: Bug#182583.
  * Yeah, it's really important not to use subterfugue in situations where
    security is vital, unless you audit everything _yourself_.  Probably not
    even then.  As a start, try looking for all of the XXXs and FIXMEs in the
    trick you're going to use...

 -- Thomas Smith <tgs@debian.org>  Sat,  1 Mar 2003 20:01:05 -0500

subterfugue (0.2.1a-5) unstable; urgency=low

  * Try fixing syscall map, which didn't have all the necessary syscalls
    (so we crashed every time :-( )
    Closes: Bug#176057
  * Commented up the file the syscalls are in to make it more obvious
    how to update it in the future.

 -- Thomas Smith <tgs@debian.org>  Thu,  9 Jan 2003 19:24:56 -0500

subterfugue (0.2.1a-4) unstable; urgency=high

  * Fixed many tricks that used the old deprecated FCNTL module and would not
    run.  (closes: #173498)
  * Some modules are still broken, I think.  Will work on them.

 -- Thomas Smith <tgs@debian.org>  Sat, 21 Dec 2002 19:38:50 -0500

subterfugue (0.2.1a-3) unstable; urgency=low

  * fixed some typos in the tricks.

 -- Thomas Smith <tgs@debian.org>  Fri,  1 Nov 2002 17:33:55 -0500

subterfugue (0.2.1a-2) unstable; urgency=low

  * ported build system to python 2.2 idiom.  Seems to work.
  * after that port, it builds for me in pbuilder.  i never tried
    it with the old build system, but... blah. (closes: #165183)

 -- Thomas Smith <tgs@debian.org>  Mon, 28 Oct 2002 21:02:09 -0500

=== debian/control ===
Source: subterfugue
Section: utils
Priority: optional
Maintainer: Thomas Smith <tgs@debian.org>
Build-Depends: debhelper (>= 2), python2.3-dev
Standards-Version: 3.5.10

Package: subterfugue
Architecture: i386
Depends: python (>= 2.3), python (<< 2.4)
Recommends: python-gtk2
Description: Tool for subverting programs--"strace meets expect"
 SUBTERFUGUE is a framework for observing and playing with the reality of
 software; it's a foundation for building tools to do tracing, sandboxing, and
 many other things.  You could think of it as "strace meets expect."
 [requires 2.4 kernel]

## subterfugue 0.2.1a-9.4

=== Makefile ===
--- 
+++ 
@@ -42,10 +42,8 @@
 
 modules/%.so : modules/%.c
 	cd modules \
-	&& (test -e Makefile.pre.in \
-	    || ln -s /usr/lib/python$(PYTHON_VERSION)/config/Makefile.pre.in) \
-	&& make -f Makefile.pre.in boot \
-	&& make
+	&& python2.3 setup.py build \
+	&& cp build/*/*.so .
 
 version := $(shell python version.py | awk '{ print $$1 }')
 distdir := subterfugue-$(version)
@@ -102,7 +100,7 @@
 clean ::
 	-rm -f sf dsf
 	-rm -f *.py[co] *~
-	-cd modules && rm -f *~ *.o *.so Makefile{,.pre} sedscript config.c
+	-cd modules && rm -f *~ *.o *.so setup.pyc setup.pyo sedscript config.c && rm -r build
 	-cd tricks && rm -f *.py[co] *~
 	-cd scripts && rm -f *~
 	-cd doc && rm -f *~

=== test/Makefile ===
# SUBTERFUGUE test makefile

#	$Header: /cvsroot/subterfugue/subterfugue/test/Makefile,v 1.6 2001/02/20 23:12:19 mkc Exp $


.PHONY : all dist clean distclean

CFLAGS = -g

PROGRAMS = badexec clone clone-signal escape fdspray fork fork-parent-dies \
  fork-rapid getenv getpidloop loop openread pauseloop pclone sigcont \
  sigreturn sleep60 sleeploop trap trapkid vfork wait-1 wait-2 wait-3 wait-4 \
  wait-5 wait-6

all :: $(PROGRAMS)

clean ::
	-rm -f *.py[co] *.o *~
	-rm -f $(PROGRAMS)

distclean :: clean
	true

=== debian/changelog ===
subterfugue (0.2.1a-9.4) unstable; urgency=medium

  * NMU
  * Change PYTHON_VERSION in postinst according to debian/rules
  * Change Depends: on python2.3 instead of python (<< 2.4) to allow upgrades
    of python (Closes: #213040, which _is_ really RC)
  * Remove CVS and .svn cruft from tarball (Closes: #212234)

 -- Ingo Saitz <ingo@debian.org>  Fri, 13 Aug 2004 14:06:31 +0200

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 
 Package: subterfugue
 Architecture: i386
-Depends: python (>= 2.3), python (<< 2.4)
+Depends: python2.3
 Recommends: python-gtk2
 Description: Tool for subverting programs--"strace meets expect"
  SUBTERFUGUE is a framework for observing and playing with the reality of

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # GNU copyright 1997 to 1999 by Joey Hess.
 
 # when changing this, need to bump control and .postinst, too!
-PYTHON_VERSION := 2.1
+PYTHON_VERSION := 2.3
 PYTHON_COMMAND = python$(PYTHON_VERSION)
 
 
@@ -74,7 +74,7 @@
 #	dh_makeshlibs
 	dh_installdeb
 #	dh_perl
-#	dh_shlibdeps
+	dh_shlibdeps
 	dh_gencontrol
 	dh_md5sums
 	dh_builddeb

## subterfugue 0.2.1a-9.5

=== Makefile ===
--- 
+++ 
@@ -42,7 +42,7 @@
 
 modules/%.so : modules/%.c
 	cd modules \
-	&& python2.3 setup.py build \
+	&& python setup.py build \
 	&& cp build/*/*.so .
 
 version := $(shell python version.py | awk '{ print $$1 }')

=== debian/changelog ===
subterfugue (0.2.1a-9.5) unstable; urgency=low

  * NMU.
  * Build using the default python version.

 -- Matthias Klose <doko@debian.org>  Fri, 27 Oct 2006 00:32:21 +0200

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # GNU copyright 1997 to 1999 by Joey Hess.
 
 # when changing this, need to bump control and .postinst, too!
-PYTHON_VERSION := 2.3
+PYTHON_VERSION := $(shell pyversions -vd)
 PYTHON_COMMAND = python$(PYTHON_VERSION)
 
 
@@ -74,6 +74,7 @@
 #	dh_makeshlibs
 	dh_installdeb
 #	dh_perl
+	dh_pycentral
 	dh_shlibdeps
 	dh_gencontrol
 	dh_md5sums

## subterfugue 0.2.1a-9.5build1

=== debian/changelog ===
subterfugue (0.2.1a-9.5build1) feisty; urgency=low

  * Rebuild for python2.5 as the default python version.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 12 Jan 2007 13:25:44 +0000

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,15 @@
 Section: utils
 Priority: optional
 Maintainer: Thomas Smith <tgs@debian.org>
-Build-Depends: debhelper (>= 2), python2.3-dev
+Build-Depends: debhelper (>= 5.0.40), python-dev, python-central (>= 0.5)
+XS-Python-Version: current
 Standards-Version: 3.5.10
 
 Package: subterfugue
 Architecture: i386
-Depends: python2.3
+Depends: ${python:Depends}
 Recommends: python-gtk2
+XB-Python-Version: ${python:Versions}
 Description: Tool for subverting programs--"strace meets expect"
  SUBTERFUGUE is a framework for observing and playing with the reality of
  software; it's a foundation for building tools to do tracing, sandboxing, and
